"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createDependencyContext = createDependencyContext;
exports.dependencyContext = exports.useDependency = exports.DependencyProvider = exports.Dependency = void 0;

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function MetaObject() {}

MetaObject.prototype = new Proxy(MetaObject.prototype, {
  get: function get(target, property, receiver) {
    if (Reflect.has(receiver, 'methodMissing')) {
      var method = receiver.methodMissing(property);

      if (method !== void 0) {
        Reflect.defineProperty(Reflect.getPrototypeOf(receiver), property, {
          value: method
        });
      }

      return method;
    }
  }
});

function createDependencyContext() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      _ref$defaultDependenc = _ref.defaultDependencies,
      defaultDependencies = _ref$defaultDependenc === void 0 ? {} : _ref$defaultDependenc,
      factory = _ref.factory,
      _ref$factoryContext = _ref.factoryContext,
      factoryContext = _ref$factoryContext === void 0 ? {} : _ref$factoryContext,
      _ref$Fallback = _ref.Fallback,
      Fallback = _ref$Fallback === void 0 ? function (_ref2) {
    var name = _ref2.name;
    return _react["default"].createElement('p', {}, 'This is placeholder for a dependency named ' + name);
  } : _ref$Fallback;

  var dependencyContext = _react["default"].createContext({
    dependencies: defaultDependencies
  });

  var factoryCache = {};

  var DependencyStore =
  /*#__PURE__*/
  function (_MetaObject) {
    _inherits(DependencyStore, _MetaObject);

    function DependencyStore() {
      _classCallCheck(this, DependencyStore);

      return _possibleConstructorReturn(this, _getPrototypeOf(DependencyStore).apply(this, arguments));
    }

    _createClass(DependencyStore, [{
      key: "methodMissing",
      value: function methodMissing(property) {
        var Component = function Component(props) {
          var DComponent = useDependency(property);

          if (!DComponent) {
            return _react["default"].createElement(Fallback, {
              name: property
            });
          }

          return _react["default"].createElement(DComponent, props);
        };

        Object.defineProperty(Component, 'name', {
          value: "Inject(".concat(property, ")"),
          writable: false,
          enumerable: false,
          configurable: true
        });
        return Component;
      }
    }]);

    return DependencyStore;
  }(MetaObject);

  var Dependency = new DependencyStore();

  function DependencyProvider(_ref3) {
    var children = _ref3.children,
        dependencies = _objectWithoutProperties(_ref3, ["children"]);

    return _react["default"].createElement(dependencyContext.Provider, {
      value: {
        dependencies: dependencies
      }
    }, children);
  }

  function useDependency(name) {
    var _React$useContext = _react["default"].useContext(dependencyContext),
        dependencies = _React$useContext.dependencies;

    if (dependencies[name]) {
      return dependencies[name];
    }

    if (!factory) {
      return dependencies[name];
    }

    if (!factoryCache[name]) {
      return factoryCache[name] = factory(name, factoryContext);
    }

    return factoryCache[name];
  }

  return {
    Dependency: Dependency,
    DependencyProvider: DependencyProvider,
    useDependency: useDependency,
    dependencyContext: dependencyContext
  };
}

var _createDependencyCont = createDependencyContext(),
    Dependency = _createDependencyCont.Dependency,
    DependencyProvider = _createDependencyCont.DependencyProvider,
    useDependency = _createDependencyCont.useDependency,
    dependencyContext = _createDependencyCont.dependencyContext;

exports.dependencyContext = dependencyContext;
exports.useDependency = useDependency;
exports.DependencyProvider = DependencyProvider;
exports.Dependency = Dependency;